<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xsl:version="1.0">

  <xsl:output method="xml"/>
  
  <xsl:template match="/">
    <matrix-public-news>
      <xsl:apply-templates/>
    </matrix-public-news>
  </xsl:template>

  <xsl:template match="news">
    <xsl:if test="net/weight&gt;=0.2">
      <xsl:call-template name="copy"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="app">
    <app>
      <xsl:apply-templates/>
      <xsl:if test="not(route)">
        <route>
          <xsl:call-template name="ins_name"/>
	</route>
      </xsl:if>
    </app>  
  </xsl:template>

  <xsl:template match="route">
    <route>
      <xsl:apply-templates/>
      <xsl:call-template name="ins_name"/>
    </route>
  </xsl:template>

  <xsl:template name="ins_name">
    <pong>someone@somewhere</pong>
  </xsl:template>

  <xsl:template match="/ | @* | node()" name="copy">
    <xsl:copy>
      <xsl:apply-templates select="@* | node()" />
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>

