/*
** Copyright (C) 2002 Tom Nicolai <nicolai@tzi.de>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef _REPORTER_
#define _REPORTER_

#include <gtk/gtk.h>

extern char TEMP_OGG_FILE[200];
extern GtkWidget *composer;
extern int expiredelta;


void init();
void cleanup();

void apply_prefs();

void broadcast();
void clear();

void status_text( const char* text );
void status_activity_on();
void status_activity_off();

#endif
