/*
** Copyright (C) 2002 Tom Nicolai <nicolai@tzi.de>, Nils Behrens <psi@tzi.de>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

/* This file is part of libmatrix
** It can publish and recommend news
*/

#ifndef __MATRIX_PUBLIC_NET_PUBLISH__
#define __MATRIX_PUBLIC_NET_PUBLISH__

#include <mpn/matrix.h>



int mpn_publish_newsitem_file( mpn_identity_ptr id, 
			       mpn_news_ptr newsdoc, 
			       mpn_newsitem_ptr newsitem, 
			       const char* srcfilename ); // ==NULL -> no file

int mpn_recommend_newsdoc( mpn_identity_ptr id, mpn_news_ptr newsdoc );
int mpn_recommend_newsitem( mpn_identity_ptr id, mpn_news_ptr newsdoc, 
			    mpn_newsitem_ptr newsitem );

//int mpn_parse_email( FILE* file, mpn_news_ptr* newsdoc_ret, char* from,
//	     char** filebuf, long* size );

#endif
